comment * 

Chat 5.0 UdeM   Desarrollado por: Richard Machado
                                  Daniel Morales
                              
Profesor: Jairo Vergara 

Arquitectura del computador - 16/Mar/2005

 *

    .486                                    ; Crea codigo de 32 bits
    .model flat, stdcall                    ; 32 bit Modelo de memoria
    option casemap :none                    ; case sensitive
 
    include \masm32\include\windows.inc     ; Librerias de windowns
    include \masm32\macros\macros.asm 
    purge select
    
; --------------------------------------------------
; include archivos para el llamado de las funciones
; --------------------------------------------------
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc
    include \masm32\include\wsock32.inc
    include \masm32\include\winmm.inc

; ------------------------------------------------
; Librerias con funciones 
; ------------------------------------------------
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\wsock32.lib
    includelib \masm32\lib\winmm.lib

    include \masm32\include\shell32.inc
    includelib \masm32\lib\shell32.lib

    include \masm32\include\debug.inc
    includelib \masm32\lib\debug.lib
; ----------------------------------------------------
; Procedimiento para mostrar variables por pantalla
; ----------------------------------------------------

    show_text PROTO :DWORD

; ----------------------------------------------------
; Segmento de Datos
; ----------------------------------------------------

.data
Port dd 4000
;txtinput  db 100 dup (0)
;txtrecv   db100 dup (0)
;txttemp   db 100 dup (0) 
welcome   db "Gracias: Por la bienvenida, att client *",13,10,0
killed    db "Se finalizo la aplicacin",13,10,0
thank     db "Hasta pronto",13,10,0
errrr     db "error.. ",0
errorr    db "A ocurrido un error.",0

.data?
s1        SOCKET ?
s2        SOCKET ?
sin1      sockaddr_in <>
sin2      sockaddr_in <>
wsaData   WSADATA <>
txtinput  dd ?
temp      dd ? 
estado    dd ?
hostt     dd ?
AdressIP  DWORD ?
HostAddr  db 256 dup(?)
MesBuff   db 512 dup(?)
RecBuff   db 512 dup(?)
edit      dd ?
prueba    dd ?
; 

.code                       

start:

inicializar: 
    print chr$("--------------------------------------------------",13,10)
    print chr$(" ",13,10)
    print chr$("              Inicio chat 5.0 - UdeM              ",13,10)
    print chr$("   Para terminar pulse CTRL + C Simultaneamente   ",13,10)    
    print chr$("--------------------------------------------------",13,10)
    ;Inicializa el DLL WindSock v1.1
    invoke WSAStartup,0101h,ADDR wsaData  
    invoke socket,PF_INET,SOCK_STREAM,IPPROTO_TCP
    mov s1,eax    
    mov ax,AF_INET
    mov sin1.sin_family,ax
    invoke htons,Port
    mov sin1.sin_port,ax
    jmp pedirIP

pedirIP:
    mov AdressIP, input("IP:")
    invoke inet_addr, addr AdressIP    
    ;cmp eax,INVALID_SOCKET
    cmp eax,INADDR_NONE
    je verporhost
    mov sin1.sin_addr,eax
    jne conexion

verporhost:
    invoke gethostbyname,ADDR HostAddr      
    push eax
    cmp eax,SOCKET_ERROR
    je errorhost
    cmp eax,0
    je errorIP2
    pop eax
    mov eax,(hostent ptr [eax]).h_list
    mov eax,[eax]			
    mov eax,[eax]
    mov sin1.sin_addr,eax
    jne conexion    
        
conexion:
    print chr$(" ",13,10) 
    invoke socket,AF_INET,SOCK_STREAM,0
    mov s2,eax    
    invoke connect, s2, addr sin1, sizeof sin1
    cmp eax,SOCKET_ERROR
    je pedirIP
    ;cmp eax,FD_READ
    jne recibir
    ;jne enviar

enviar:
    print chr$("Conectado.",13,10)
    print chr$("--------------------------------------------------",13,10)   
    jmp enviini

enviini:
    invoke send, s2,ADDR welcome,SIZEOF welcome,0
    ;cmp eax,SOCKET_ERROR
    ;je errors
    cmp eax,FD_READ    
    je recibir
    jne siguenv
    
siguenv:   
    mov txtinput, input("ENV:")    
    print chr$("Se Envio",13,10)             
    print txtinput
    print chr$(" ",13,10)             
    invoke lstrlen, addr txtinput   
    cmp eax,100
    jg errorcadena
    invoke send,s2,ADDR txtinput,SIZEOF txtinput,0
    cmp eax,SOCKET_ERROR
    je errors         
    jne siguenv
    ;jne recibir
    
recibir:
    print chr$("REC:")
    jmp siguere
    
siguere:
    invoke recv,s2,ADDR RecBuff,SIZEOF RecBuff,0
    cmp eax,SOCKET_ERROR
    je errorecibe
    cmp edit,0
    je errorsr
    print str$(edit)
    print chr$(" ",13,10)             
    jne siguere
    ret    

e:
    print chr$("Error socket.",13,10)
    ret

errorhost:
    cls
    print chr$("Error host o IP.",13,10)
    jmp pedirIP

    
errorcadena:
    print chr$("La cadena de texto excede las 100 posiciones.",13,10)
    print chr$("Intente de Nuevo.",13,10)
    jmp siguenv    

errors:
    print chr$("Envio fallo. Usuario probablemente desconectado.",13,10)
    jmp enviini 

errorIP:
    print chr$("Direccion IP no valida. Intente de Nuevo",13,10)
    jmp inicializar
    ret

errorIP2:
    print chr$("Error al resolver direccion IP",13,10)
    jmp inicializar
    ret

errodll:
    cls
    print chr$("El controlador Winsock.dll, No se pudo inicializar en su maquina.",13,10)
    mov eax, input("Pulse ENTER para reintentar...")    
    jmp inicializar 

errorsr:
    jmp siguere    

errorecibe:
    print chr$("Recepcion fallo.",13,10)
    jmp siguere

salir:  
    invoke send,s2,ADDR thank,SIZEOF thank,0
    invoke send,s2,ADDR killed,SIZEOF killed,0
    invoke closesocket,s1
    invoke closesocket,s2
    invoke WSACleanup
    xor eax,eax
    ret    

    ;print OFFSET txtinput
    ;PrintString txtinput print debug
    ;invoke MessageBox, 0, ADDR txtinput, 0, MB_OK                      

;--------------------------------
show_text proc string:DWORD
;ver el string por consola
    print chr$(" ",13,10,"*")
    print string                
    print chr$("*",13,10)
    print chr$(" ",13,10)
    ret
show_text endp

end start      
